<?PHP

#######################
# Module: Online Pro
# Developed by IMP
# IranDatalife.com
#######################


if( !defined( 'DATALIFEENGINE' ) ) {
	header( 'HTTP/1.1 403 Forbidden' );
	header ( 'Location: ../../' );
	die( 'Hacking attempt!' );
}

define( 'ONLINE_DATABASE', ENGINE_DIR . '/modules/imp_online_pro/history.txt' );

########## Get real ip function
function getUserIP() {
    if ( !empty( $_SERVER['HTTP_CLIENT_IP'] ) ) {
        //IP from share internet
        $UserIP = $_SERVER['HTTP_CLIENT_IP'];
    } elseif ( !empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) {
        //IP pass from proxy
        $UserIP = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
        $UserIP = $_SERVER['REMOTE_ADDR'];
    }
    return $UserIP;
}

########## Time ago function
function get_timeago( $Ptime ) {
    $Estimate_Time = time() - $Ptime;

    if ( $Estimate_Time < 1 ) return 'حدود یک ثانیه پیش';

    $Condition = array( 
      12 * 30 * 24 * 60 * 60  =>  'سال',
      30 * 24 * 60 * 60       =>  'ماه',
      24 * 60 * 60            =>  'روز',
      60 * 60                 =>  'ساعت',
      60                      =>  'دقیقه',
      1                       =>  'ثانیه'
    );

    foreach( $Condition as $Secs => $Str ) {
        $Digit = $Estimate_Time / $Secs;

        if( $Digit >= 1 ) {
            $Rounded = round( $Digit );
            return 'حدود ' . $Rounded . ' ' . $Str . ' پیش';
        }
    }
}

//Get visitor IP
$Visitor_IP = getUserIP();

//Get counter values
$Data_Old = unserialize( file_get_contents( ONLINE_DATABASE ) );

//Today date
$Today_Date = jdate( 'Ymd' );
$Time_Now = strtotime( 'now' );

//Check new day
$Is_New_Day = ( $Data_Old['TODAY'] === $Today_Date ) ? false : true;

//Create total views
$Total_Views = $Data_Old['TOTAL_VIEWS'] + 1;

//Make new data for the new day
if ( $Is_New_Day || !is_array( $Data_Old ) ) {

  $Total_IP = $Data_Old['TOTAL_IP'] + 1;
  
  $Yesterday_Total_IP = $Data_Old['TODAY_IP_COUNT'];
  $Yesterday_Total_Views = $Data_Old['TODAY_VIEW_HITS'];
  
  $Today_IP_Count = '1';
  $Today_View_Hits = '1';

  //Generate new data
  $New_Counter_Data = array(
    'TODAY' => $Today_Date,
    'TOTAL_IP' => $Total_IP,
    'TOTAL_VIEWS' => $Total_Views,
    'YESTERDAY_TOTAL_IP_COUNT' => $Data_Old['TODAY_IP_COUNT'],
    'YESTERDAY_TOTAL_VIEWS' => $Data_Old['TODAY_VIEW_HITS'],
    'TODAY_VIEW_HITS' => $Today_View_Hits,
    'TODAY_IP_COUNT' => $Today_IP_Count,
    'TODAY_IP_LIST' => array( $Visitor_IP ),
    'TODAY_MEMBER_LIST' => array( $Visitor_IP => array( 'USER_ID' => $member_id['user_id'], 'USER_GROUP' => $member_id['user_group'], 'USER_NAME' => $member_id['name'], 'USER_TIME' => $Time_Now ) )
  );

} else {

  //Yesterday values
  $Yesterday_Total_IP = $Data_Old['YESTERDAY_TOTAL_IP_COUNT'];
  $Yesterday_Total_Views = $Data_Old['YESTERDAY_TOTAL_VIEWS'];

  //Update today IP list
  if ( in_array( $Visitor_IP, $Data_Old['TODAY_IP_LIST'] ) ) {

    $Data_Old['TODAY_IP_LIST'] = $Data_Old['TODAY_IP_LIST'];
    $Today_IP_Count = $Data_Old['TODAY_IP_COUNT'];
    $Total_IP = $Data_Old['TOTAL_IP'];

  } else {

    $Data_Old['TODAY_IP_LIST'][] = $Visitor_IP;
    $Today_IP_Count = $Data_Old['TODAY_IP_COUNT'] + 1;
    $Total_IP = $Data_Old['TOTAL_IP'] + 1;

  }
  
  //Update today views
  $Today_View_Hits = $Data_Old['TODAY_VIEW_HITS'] + 1;

  //Remove old online visitors
  foreach( $Data_Old['TODAY_MEMBER_LIST'] as $Key => $Value ) {

    //Check and remove records by the time
    if ( $Value['USER_TIME'] + 300 < $Time_Now ) unset( $Data_Old['TODAY_MEMBER_LIST'][$Key] );
    //Check and remove duplicate members
    if ( $Value['USER_ID'] == $member_id['user_id'] ) unset( $Data_Old['TODAY_MEMBER_LIST'][$Key] );

  }

  //Check if visitor are available on the list
  if ( array_key_exists( $Visitor_IP, $Data_Old['TODAY_MEMBER_LIST'] ) ) unset( $Data_Old['TODAY_MEMBER_LIST'][$Visitor_IP] );

  //Generate new member list with fresh data
  $Data_Old['TODAY_MEMBER_LIST'][$Visitor_IP] = array( 'USER_ID' => $member_id['user_id'] ? $member_id['user_id'] : '0', 'USER_GROUP' => $member_id['user_group'], 'USER_NAME' => $member_id['name'] ? $member_id['name'] : '_Guest_', 'USER_TIME' => $Time_Now );  

  //Update the old data
  $New_Counter_Data = array(
    'TODAY' => $Today_Date,
    'TOTAL_IP' => $Total_IP,
    'TOTAL_VIEWS' => $Total_Views,
    'YESTERDAY_TOTAL_IP_COUNT' => $Data_Old['YESTERDAY_TOTAL_IP_COUNT'],
    'YESTERDAY_TOTAL_VIEWS' => $Data_Old['YESTERDAY_TOTAL_VIEWS'],
    'TODAY_VIEW_HITS' => $Today_View_Hits,
    'TODAY_IP_COUNT' => $Today_IP_Count,
    'TODAY_IP_LIST' => $Data_Old['TODAY_IP_LIST'],
    'TODAY_MEMBER_LIST' => $Data_Old['TODAY_MEMBER_LIST']
  );

}

//Submit new data to the text file
file_put_contents( ONLINE_DATABASE, serialize( $New_Counter_Data ) );

//Generate new template
$tpl_a = new dle_template();
$tpl_a->dir = ROOT_DIR . '/engine/modules/imp_online_pro/';

//Sort views by time value
usort( $Data_Old['TODAY_MEMBER_LIST'], function( $Item_A, $Item_B ) {
  if ($Item_A['USER_TIME'] == $Item_B['USER_TIME']) return 0;
  return $Item_A['USER_TIME'] < $Item_B['USER_TIME'] ? -1 : 1;
} );

########## Generate online list
foreach( $New_Counter_Data['TODAY_MEMBER_LIST'] as $Key => $Value ) {

  if ( $Value['USER_ID'] > '0' ) {

    $Member_Page = $config['http_home_url'] . 'user/' . urlencode( $Value['USER_NAME'] ) . '/';
    $Member_Color_Name = $user_group[$Value['USER_GROUP']]['group_prefix'] . $Value['USER_NAME'] . $user_group[$Value['USER_GROUP']]['group_suffix'];
    $Member_Name[] = '<a onclick="ShowProfile( \''.$Value['USER_NAME'].'\', \''.$Member_Page.'\' ); return false;" href="'.$Member_Page.'" title="'.get_timeago($Value['USER_TIME']).'">'.$Member_Color_Name.'</a>';
    $Total_Online_Members++; //Calculate total of online registered members

  } else {

    $Total_Guests++; //Calculate available guests on website

  }

}
$Online_Members = implode( ', ', $Member_Name );

########## Load templates
$tpl_a->load_template( 'template.tpl' );
  $tpl_a->set( '{today}', $Today_IP_Count );
  $tpl_a->set( '{today-hits}', $Today_View_Hits );
  $tpl_a->set( '{online-members}', $Online_Members );

  if ( $Total_Online_Members ) {
    $tpl_a->set( '[total-online-members]', '' );
    $tpl_a->set( '[/total-online-members]', '' );
    $tpl_a->set( '{total-online-members}', $Total_Online_Members );
  } else {
    $tpl_a->set( '{total-online-members}', "" );
    $tpl_a->set_block( "'\\[total-online-members\\](.*?)\\[/total-online-members\\]'si", '' );
  }

  if ( $Total_Guests ) {
    $tpl_a->set( '[total-guests]', '' );
    $tpl_a->set( '[/total-guests]', '' );
    $tpl_a->set( '{total-guests}', $Total_Guests );
  } else {
    $tpl_a->set( '{total-guests}', "" );
    $tpl_a->set_block( "'\\[total-guests\\](.*?)\\[/total-guests\\]'si", '' );
  }

  $tpl_a->set( '{online-guests}', $Total_Guests );
  $tpl_a->set( '{online-total}', $Total_Guests + $Total_Online_Members );

  // Yesterday informations
  $tpl_a->set( '{yesterday-total-ip}', $Yesterday_Total_IP ?: '0' );
  $tpl_a->set( '{yesterday-total-views}', $Yesterday_Total_Views ?: '0' );
  
  //Today's date
  $tpl_a->set( '{today-date}', jdate( 'l، j F Y', $Time_Now ) );

  //Total tags
  $tpl_a->set( '{total-ip}', $Total_IP );
  $tpl_a->set( '{total-views}', $Total_Views );

$tpl_a->compile( 'online_pro' );
$tpl_a->clear();

echo $tpl_a->result['online_pro'];